=== debian/changelog ===
csound (1:5.14.2~dfsg-2) unstable; urgency=low

  * Fix broken lua module symlink (symlink did not get updated when the lua
    module changed names).
  * Fix FTBFS with -Werror=format-security. Closes: #649462

 -- Felipe Sateler <fsateler@debian.org>  Wed, 23 Nov 2011 22:06:19 -0300

csound (1:5.14.2~dfsg-1) unstable; urgency=low

  [ Felipe Sateler ]
  * New upstream release
   - Update copyright file
   - Remove patch applied upstream
   - Refresh patches
   - Beats has been renamed to csbeats
  * Delete custom.py on clean
  * Install new plugins
  * Enable the new Lua opcodes
  * Enable new parser

  [ Jonas Smedegaard ]
  * Update copyright file:
    + Rewrite to DEP5 rev. 174 format.
    + Fix update more entries.

 -- Felipe Sateler <fsateler@debian.org>  Wed, 02 Nov 2011 19:56:26 -0300

csound (1:5.13.0~dfsg-5) unstable; urgency=low

  * Use linux-any wildcard for libasound dependency. Closes: #634489
  * Build only for the current python version.
     Closes: #642708

 -- Felipe Sateler <fsateler@debian.org>  Sun, 25 Sep 2011 16:19:59 -0300
